=== debian/changelog ===
texworks (0.6.5-2) unstable; urgency=medium

  [ Debian Janitor ]
  * Use secure URI in Homepage field.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Fix day-of-week for changelog entry 0.5~svn1026-1.

  [ Hilmar Preusse ]
  * Lintian:
    - duplicate-changelog-files usr/share/doc/texworks/NEWS.gz
      usr/share/doc/texworks/changelog.gz
    - debian-watch-file-is-missing

  [ Norbert Preining ]
  * Fix build with Qt 5.15 (Closes: #975116, #975118)

 -- Norbert Preining <norbert@preining.info>  Thu, 19 Nov 2020 19:34:23 +0900

texworks (0.6.5-1) unstable; urgency=medium

  * New upstream version 0.6.5
  * Bump debhelper compat to 12

 -- Norbert Preining <norbert@preining.info>  Thu, 26 Mar 2020 07:22:38 +0900

texworks (0.6.4-1) unstable; urgency=medium

  * New upstream version 0.6.4

 -- Norbert Preining <norbert@preining.info>  Mon, 16 Mar 2020 06:15:52 +0900
